#ifndef _MCSIMPLE_H_
#define _MCSIMPLE_H_

#include<functional>
#include<algorithm>
#include<numeric>
#include<cmath>
#include<iostream>
#include "RNorm.hpp"

struct McResult{
    public:
    double mu;
    double stat;
};

// We mirror the definitions from the python code
McResult mc_nonvec(std::function<double(double)> f, RNorm& rnorm, int M);

McResult mc_scalar(std::function<double(double)> f, RNorm& rnorm, int M);

McResult mc_max_naive(RNorm& rnorm, int M, int N);

McResult mc_max_partial(RNorm& rnorm, int M, int N);

McResult mc_max(RNorm& rnorm, int M, int N);

#endif